using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    [Obsolete]
    public class GasEmitter : MonoBehaviour
    {
        public float gasRate;
        public float fuseTime;
        public bool fuse;
        float defRate;
        [SerializeField]
        public bool infiniteGas;
        [SerializeField]
        public int gasAmount = 100;
        [SerializeField]
        int gasMax;
        public bool toggled;
        [SerializeField]
        public Gas properties;
        public Vector3 offset;
        public AudioClip[] sounds = new AudioClip[3];
        public AudioSource audio;
        public Vector3 gasScale = new Vector3(1, 1, 1);
        public Vector3 initialScale = new Vector3(.1f, .1f, .1f);
        public Color gasColor;
        public Sprite gasSprite;
        public bool explosive;
        public List<Vector3> holePositions;
        int butPos = 0;

        public Gas gas;

        void Start()
        {
            ContextMenu();
            if (fuseTime != 0)
                StartCoroutine(Fuse());
            defRate = gasRate;
            audio = gameObject.AddComponent<AudioSource>();
            audio.loop = true;
            audio.volume = .075f;
            audio.playOnAwake = false;
            audio.clip = sounds[1];
            gasMax = gasAmount;
        }
        void Use()
        {
            if (fuseTime > 0)
            {
                if (!fuse)
                    fuse = true;
                else
                    fuse = false;
                return;
            }
            if (!toggled && gasAmount > 0)
            {
                toggled = true;
                audio.Play();
                StartCoroutine(ContinuousSpawn());
            }
            else
            {
                toggled = false;
                audio.Stop();
            }
        }
        void Update()
        {
            gasRate = defRate * Time.timeScale;
        }
        public IEnumerator Fuse()
        {
            while (fuseTime > 0)
            {
                if (fuse)
                    fuseTime -= Time.deltaTime;
                yield return null;
            }
            ModAPI.CreateParticleEffect("FuseBlown", transform.position);
            toggled = true;
            StartCoroutine(ContinuousSpawn());
            audio.Play();
            StopCoroutine("Fuse");
        }
        public IEnumerator ContinuousSpawn()
        {
            while (toggled)
            {
                if (gasAmount > 0)
                    SpawnGas();
                else
                {
                    toggled = false;
                    audio.Stop();
                }
                yield return new WaitForSeconds(gasRate);
            }
        }
        public void SpawnGas()
        {
            Vector3 randomOffset = new Vector3(UnityEngine.Random.Range(-.1f, .1f), UnityEngine.Random.Range(-.1f, .1f));
            GameObject gasObj = new GameObject("gasobject");
            gasObj.layer = 9;
            gasObj.AddComponent<SpriteRenderer>().sprite = gasSprite;
            Rigidbody2D gasrb = gasObj.AddComponent<Rigidbody2D>();
            gasrb.gravityScale = 0;
            gasObj.transform.parent = transform;
            gasrb.AddForce(transform.up * 20f);

            gasObj.transform.localPosition = Vector3.zero + randomOffset + offset;

            gasObj.transform.parent = null;
            CircleCollider2D col = gasObj.AddComponent<CircleCollider2D>();
            col.isTrigger = true;
            GasBehaviour gasBehaviour = gasObj.AddComponent<GasBehaviour>();
            gasBehaviour.gas = gas;

            // Gas Properties
            //gasBehaviour.scale = gasScale;
            //gasBehaviour.initialScale = initialScale;

            //gasBehaviour.wind = UnityEngine.Random.Range(properties.windMin, properties.windMax);
            //gasBehaviour.lifeTime = UnityEngine.Random.Range(properties.lifeMin, properties.lifeMax);

            gasBehaviour.gas = properties;

            if (!infiniteGas)
                gasAmount--;
        }
        public void Explode()
        {

        }
        public void Refill()
        {
            gasAmount = gasMax;
        }
        private void Shot(global:: Shot shot)
        {
            //holePositions.Add(shot.point);
        }
        void ContextMenu()
        {
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("windbut", "Edit direction and speed", "Change how fast the gas moves.", new UnityAction[1]
            {
                (UnityAction) (() =>
            {
                DialogBox dialog = (DialogBox) null;
                dialog = DialogBoxManager.TextEntry("Change how fast the gas moves. Negative values will cause the gas to move left. Speed is randomized, so you have to input two values. Base speed values are 0 to 20", "Min, Max", new DialogButton("Apply", true, new UnityAction[1]
                {     
                    (UnityAction) (() =>
                    {
                        if (dialog.EnteredText != "")
                        {;
                            var text = dialog.EnteredText.Split(","[0]);
                            ModAPI.Notify("Speed set to " + dialog.EnteredText);
                            //properties.windMin = float.Parse(text[0]) / 100;
                            //properties.windMax = float.Parse(text[1]) / 100;
                        }
                        else
                            ModAPI.Notify("You didn't input anything. Wind values unchanged.");
                        })
                }),
                new DialogButton("Cancel", true, new UnityAction[1]
                    {
                        (UnityAction) (() => dialog.Close())
                    }));
                })
            }));
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("gasbut", "Change gas type", "Switch what type of gas is in the canister.", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    butPos = 0;
                    DialogBox dialog = (DialogBox) null;
                    dialog = DialogBoxManager.TextEntry("Switch the type of gas that is in the canister.", "", 
                    new DialogButton("<<", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 0)
                                return;
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Mustard Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Mustard);
                        })
                    }),    
                    new DialogButton("Chlorine Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Chlorine);
                        })
                    }),
                    new DialogButton(">>", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 2)
                                return;
                            butPos++;
                            CheckDialogArea(dialog);
                        })
                    }));
                dialog.ShowTextBox = false;
                })
            }));
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("mutebut", "Mute / Unmute", "Make the canister shut up or make it not shut up.", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    if (audio.enabled)
                        audio.enabled = false;
                    else
                        audio.enabled = true;
                })
            }));
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("refbut", "Refill canister", "Refill the canister.", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    Refill();
                })
            }));
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("capbut", "Edit capacity", "Change how much gas the canister can store.", new UnityAction[1]
            {
                (UnityAction) (() =>
            {
                DialogBox dialog = (DialogBox) null;
                dialog = DialogBoxManager.TextEntry("Change the amount of gas stored in the canister.", "", new DialogButton("Apply", true, new UnityAction[1]
                {     
                    (UnityAction) (() =>
                    {
                        if (dialog.EnteredText != "")
                        {;
                            gasMax = int.Parse(dialog.EnteredText);
                            ModAPI.Notify("Gas amount set to " + int.Parse(dialog.EnteredText).ToString());
                            Refill();
                        }
                        else
                            ModAPI.Notify("You didn't input anything. Gas amount unchanged.");
                        })
                }),
                new DialogButton("Toggle Infinite Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() => {
                            if (!infiniteGas)
                            {
                                infiniteGas = true;
                                Refill();
                            }
                            else
                                infiniteGas = false;
                        })
                    }),
                new DialogButton("Cancel", true, new UnityAction[1]
                    {
                        (UnityAction) (() => dialog.Close())
                    }));
                })
            }));
        }
        void CheckDialogArea(DialogBox dialogBox)
        {
            DialogBox dialog = (DialogBox)null;
            switch(butPos)
            {
                case 0:
                    dialog = DialogBoxManager.TextEntry("Switch the type of gas that is in the canister.", "",
                    new DialogButton("<<", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 0)
                            {
                                dialog.Close();
                                return;
                            }
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Mustard Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Mustard);
                        })
                    }),
                    new DialogButton("Chlorine Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Chlorine);
                        })
                    }),
                    new DialogButton(">>", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 2)
                                return;
                            butPos++;
                            CheckDialogArea(dialog);
                        })
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
                case 1:
                    dialog = DialogBoxManager.TextEntry("Switch the type of gas that is in the canister.", "",
                    new DialogButton("<<", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 0)
                                return;
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Hydrogen Cyanide", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Cyanide);
                        })
                    }),
                    new DialogButton("Knockout Gas", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Knockout);
                        })
                    }),
                    new DialogButton(">>", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 2)
                                return;
                            butPos++;
                            CheckDialogArea(dialog);
                        })
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
                case 2:
                    dialog = DialogBoxManager.TextEntry("Switch the type of gas that is in the canister.", "",
                    new DialogButton("<<", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 0)
                                return;
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Zombie Neurotoxin", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            //properties.SetGasProperties(GasProperties.GasType.Zombie);
                        })
                    }),
                    new DialogButton(">>", true, new UnityAction[1]
                    {
                        (UnityAction) (() =>
                        {
                            if (butPos == 2)
                            {
                                dialog.Close();
                                return;
                            }
                            butPos++;
                            CheckDialogArea(dialog);
                        })
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
            }
        }
    }
}
