using System;
using System.Collections.Generic;
using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static Dictionary<string, ArmorProperties> armor = new Dictionary<string, ArmorProperties>();
        public static Dictionary<string, Gas> gas = new Dictionary<string, Gas>();
        public static Sprite gasSprite = ModAPI.LoadSprite("sprites/gas.png");
        public static AudioClip[] gasSounds = new AudioClip[]
        {
            ModAPI.LoadSound("sfx/steamstart.mp3"),
            ModAPI.LoadSound("sfx/steamloop.mp3"),
            ModAPI.LoadSound("sfx/steamend.mp3")
        };
        static bool done = false;
        public static void Armor() // call before gas
        {
            if (done)
                return;
            PhysicalProperties prop = UnityEngine.Object.Instantiate(ModAPI.FindPhysicalProperties("Bowling pin"));
            prop.BulletSpeedAbsorptionPower = 0.5f;
            prop.Softness = 0.5f;

            armor.Add("gasmask", 
            new ArmorProperties("Head", ModAPI.LoadSprite("sprites/gasmask.png"), new Vector3(.02f, .015f), new Vector3(.01f, .01f), 10, prop, false, true));

            armor.Add("hazmat1",
            new ArmorProperties("Head", ModAPI.LoadSprite("sprites/hazmathat.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, true));
            armor.Add("hazmat2",
            new ArmorProperties("UpperBody", ModAPI.LoadSprite("sprites/hazmatupper.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat3",
            new ArmorProperties("MiddleBody", ModAPI.LoadSprite("sprites/hazmatmid.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat4",
            new ArmorProperties("LowerBody", ModAPI.LoadSprite("sprites/hazmatlower.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat5",
            new ArmorProperties("UpperArm", ModAPI.LoadSprite("sprites/hazmatshoulder.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat6",
            new ArmorProperties("UpperArmFront", ModAPI.LoadSprite("sprites/hazmatshoulder.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat7",
            new ArmorProperties("LowerArm", ModAPI.LoadSprite("sprites/hazmatarm.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat8",
            new ArmorProperties("LowerArmFront", ModAPI.LoadSprite("sprites/hazmatarm.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat9",
            new ArmorProperties("UpperLeg", ModAPI.LoadSprite("sprites/hazmatthigh.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat10",
            new ArmorProperties("UpperLegFront", ModAPI.LoadSprite("sprites/hazmatthigh.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat11",
            new ArmorProperties("LowerLeg", ModAPI.LoadSprite("sprites/hazmatleg.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat12",
            new ArmorProperties("LowerLegFront", ModAPI.LoadSprite("sprites/hazmatleg.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat13",
            new ArmorProperties("Foot", ModAPI.LoadSprite("sprites/hazmatboot.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
            armor.Add("hazmat14",
            new ArmorProperties("FootFront", ModAPI.LoadSprite("sprites/hazmatboot.png"), Vector3.zero, new Vector3(.01f, .01f), 5, prop, true, false));
        }
        public static void Gas()
        {
            if (done)
                return;
            void ZombieNeurotoxin()
            {
                Symptom Damage = ScriptableObject.CreateInstance<Symptom>();
                Damage.time = 0f;
                Damage.mild = 1f;
                Damage.moderate = 0f;
                Damage.severe = 0f;
                Damage.nonexposedMultiplier = 0f;
                Damage.healthEffect = (x, y) => x.IsZombie ? x.Health : x.Health - (5f * Time.fixedDeltaTime * y);
                Damage.name = "Death";
                Symptom Zombification = ScriptableObject.CreateInstance<Symptom>();
                Zombification.time = 0f;
                Zombification.delay = 15f;
                Zombification.mild = 0f;
                Zombification.moderate = 0.5f;
                Zombification.severe = 1f;
                Zombification.nonexposedMultiplier = 0f;
                Zombification.otherEffects = new Action<GameObject, float>[]
                {
                    (GameObject obj, float multiplier) =>
                    {
                        LimbBehaviour limb = obj.GetComponent<LimbBehaviour>();
                        limb.IsZombie = true;
                        limb.Health = limb.InitialHealth;
                        limb.Numbness = 0.0f;
                        CirculationBehaviour circulationBehaviour = limb.CirculationBehaviour;
                        float amount = circulationBehaviour.GetAmount(limb.GetOriginalBloodType());
                        if (amount < 0.100000001490116)
                        {
                            double num = circulationBehaviour.AddLiquid(limb.GetOriginalBloodType(), 1f - amount);
                        }
                        circulationBehaviour.BloodFlow = 1f;
                        circulationBehaviour.HealBleeding();
                        circulationBehaviour.BleedingRate = 0.0f;
                        circulationBehaviour.IsPump = circulationBehaviour.WasInitiallyPumping;
                        if (limb.RoughClassification != LimbBehaviour.BodyPart.Head)
                            return;
                        limb.Person.Consciousness = 1f;
                        limb.Person.ShockLevel = 0.0f;
                        limb.Person.PainLevel = 0.0f;
                        limb.Person.OxygenLevel = 1f;
                        limb.Person.AdrenalineLevel = 1f;
                    }
                };
                Zombification.name = "Reanimation";
                gas.Add("zombie neurotoxin", new Gas(-0.05f, 16f, 18f, new Color(0.41f, 0.74f, 0.18f), new Symptom[]
                {
                    Damage, Zombification
                }));
            }
            void ChlorineGas()
            {
                Symptom Burns = ScriptableObject.CreateInstance<Symptom>();
                Burns.time = 0f;
                Burns.severe = 1.25f;
                Burns.inhalationExposureMultiplier = 0f;
                Burns.nonexposedMultiplier = 0f;
                Burns.acidEffect = (x, y) => x < 0.4f * y ? x + (0.01f * Time.fixedDeltaTime) : x;
                Burns.shockEffect = (x, y) => x < 0.05f * y ? 0.05f * y : x;
                Burns.name = "Burns";
                Symptom Breathing = ScriptableObject.CreateInstance<Symptom>();
                Breathing.time = 30f;
                Breathing.chance = 0.5f;
                Breathing.mild = 1;
                Breathing.moderate = 1.25f;
                Breathing.severe = 1.25f;
                Breathing.nonexposedMultiplier = 0.8f;
                Breathing.breathIntakeEffect = (x, y) => Mathf.Min(x, 0.2f / y);
                Breathing.lungEffect = (x, y) => Mathf.Min(x, 0.9f / y);
                Breathing.skinExposureMultiplier = 0f;
                Breathing.name = "Dyspnea";
                Symptom Fluid = ScriptableObject.CreateInstance<Symptom>();
                Fluid.time = 30f;
                Fluid.chance = 0.5f;
                Fluid.delay = 20f;
                Fluid.mild = 0.05f;
                Fluid.moderate = 0.5f;
                Fluid.severe = 3f;
                Fluid.nonexposedMultiplier = 0.8f;
                Fluid.lungEffect = (x, y) => Mathf.Min(x - (0.01f * y * Time.fixedDeltaTime), 0.6f / y);
                Fluid.skinExposureMultiplier = 0f;
                Fluid.name = "Pulmonary edema";
                gas.Add("chlorine gas", new Gas(-0.15f, 10f, 12f, new Color(0.82f, 1f, 0.5f), new Symptom[]
                {
                    Burns, Breathing, Fluid
                }));
            }
            void MustardGas() // tune health and acid damage
            {
                // causes burns around the body
                Symptom Burns = ScriptableObject.CreateInstance<Symptom>();
                Burns.time = 0f;
                Burns.mild = 0.75f;
                Burns.moderate = 0.9f;
                Burns.severe = 1f;
                Burns.inhalationExposureMultiplier = 0f;
                Burns.nonexposedMultiplier = 0f;
                Burns.acidEffect = (x, y) => x < 0.6f * y ? x + (0.01f * Time.fixedDeltaTime * y) : x;
                Burns.burnDamageEffect = (x, y) => x < 0.1f * y ? x + (0.001f * Time.fixedDeltaTime * y) : x;
                Burns.healthEffect = (x, y) => x.Health > x.InitialHealth / 2 ? x.Health - (0.1f * UnityEngine.Random.value * Time.fixedDeltaTime * y) : x.Health;
                Burns.shockEffect = (x, y) => x < 0.51f * y ? x + (0.005f * y * Time.fixedDeltaTime) : x;
                Burns.name = "Burns and blistering";
                Symptom Inhalation = ScriptableObject.CreateInstance<Symptom>();
                Inhalation.time = 180f;
                Inhalation.delay = 2f;
                Inhalation.mild = 0.25f;
                Inhalation.moderate = 1f;
                Inhalation.severe = 10f;
                Inhalation.nonexposedMultiplier = 0.8f;
                Inhalation.breathTimeEffect = (x, y) => Mathf.Min(x, 0.95f);
                Inhalation.breathIntakeEffect = (x, y) => Mathf.Min(x, 0.2f);
                Inhalation.lungEffect = (x, y) => Mathf.Min(x - (0.001f * Time.fixedDeltaTime * y), 0.95f);
                Inhalation.skinExposureMultiplier = 0f;
                Inhalation.name = "Shortness of breath";
                gas.Add("mustard gas", new Gas(-0.1f, 10f, 12f, new Color(1f, 1f, 0.45f), new Symptom[]
                {
                    Burns, Inhalation
                }));
            }
            void HydrogenCyanide()
            {
                // speeds up breathing and increases depth of breathing
                Symptom RapidBreathing = ScriptableObject.CreateInstance<Symptom>();
                RapidBreathing.time = 20f;
                RapidBreathing.breathTimeEffect = (x, y) => Mathf.Min(x, 0.75f / y);
                RapidBreathing.breathIntakeEffect = (x, y) => Mathf.Max(x, 0.225f * y);
                RapidBreathing.mild = 1f;
                RapidBreathing.severe = 1.25f;
                RapidBreathing.skinExposureMultiplier = 0f;
                RapidBreathing.name = "Hyperpnea";
                // instantly stops breathing
                Symptom RespiratoryArrest = ScriptableObject.CreateInstance<Symptom>();
                RespiratoryArrest.time = 180f;
                RespiratoryArrest.delay = 5f;
                RespiratoryArrest.chance = 1f;
                RespiratoryArrest.mild = 0;
                RespiratoryArrest.moderate = 0.5f;
                RespiratoryArrest.severe = 1;
                RespiratoryArrest.skinExposureMultiplier = 0f;
                RespiratoryArrest.lungEffect = (x, y) => x = 0;
                RespiratoryArrest.name = "Respiratory arrest";
                // kills
                Symptom Death = ScriptableObject.CreateInstance<Symptom>();
                Death.time = 180f;
                Death.delay = 30f;
                Death.chance = 0.25f;
                Death.mild = 0f;
                Death.moderate = 0f;
                Death.skinExposureMultiplier = 2f;
                Death.inhalationExposureMultiplier = 0.5f;
                Death.healthEffect = (x, y) => x.Health > 0 ? x.Health - Mathf.Min(0.5f * y, x.Health) : x.Health = 0;
                Death.otherEffects = new Action<GameObject, float>[]
                {
                    (GameObject obj, float multiplier) =>
                    {
                        LimbBehaviour limb = obj.GetComponent<LimbBehaviour>();
                        limb.CirculationBehaviour.IsPump = false;
                    }
                };
                Death.name = "Death";
                // complete unconsciousness for an extended period of time
                Symptom Coma = ScriptableObject.CreateInstance<Symptom>();
                Coma.time = 360f;
                Coma.delay = 10f;
                Coma.chance = 0.5f;
                Coma.mild = 0;
                Coma.moderate = 0;
                Coma.severe = 1;
                Coma.consciousnessEffect = (x, y) => x = 0;
                Coma.name = "Coma";
                // causes muscle spasms
                Symptom Spasms = ScriptableObject.CreateInstance<Symptom>();
                Spasms.time = 20f;
                Spasms.chance = 0.1f;
                Spasms.mild = 0;
                Spasms.moderate = 0;
                Spasms.severe = 1;
                Spasms.spasmChance = 0.5f;
                Spasms.spasmIntensity = 100;
                Spasms.name = "Muscle spasms";
                // hydrogen cyanide
                gas.Add("hydrogen cyanide", new Gas(0.025f, 10f, 12f, Color.white, new Symptom[]{
                    RapidBreathing, RespiratoryArrest, Death, Coma, Spasms
                }));
            }
            void KnockoutGas()
            {
                Symptom Knockout = ScriptableObject.CreateInstance<Symptom>();
                Knockout.time = 0f;
                Knockout.chance = 0.5f;
                Knockout.consciousnessEffect = (x, y) => 0;
                Knockout.name = "Knockout";
                Knockout.nonexposedMultiplier = 0f;
                Knockout.skinExposureMultiplier = 0f;
                Symptom Coma = ScriptableObject.CreateInstance<Symptom>();
                Coma.time = 60f;
                Coma.delay = 10f;
                Coma.chance = 0.1f;
                Coma.mild = 0f;
                Coma.moderate = 0f;
                Coma.severe = 1f;
                Coma.consciousnessEffect = (x, y) => 0;
                Coma.name = "Coma";
                Coma.skinExposureMultiplier = 0f;
                // after 60 seconds of severe exposure, death occurs
                Symptom Death = ScriptableObject.CreateInstance<Symptom>();
                Death.time = 5f;
                Death.delay = 60f;
                Death.chance = 0.05f;
                Death.mild = 0f;
                Death.moderate = 0f;
                Death.severe = 1f;
                Death.healthEffect = (x, y) => x.Health - (5 * Time.fixedDeltaTime * y);
                Death.name = "Death";
                Death.skinExposureMultiplier = 0f;
                gas.Add("knockout gas", new Gas(-0.05f, 14f, 16f, new Color(0.5f, 1f, 1f), new Symptom[]
                {
                    Knockout, Coma, Death
                }));
            }

            ChlorineGas();
            HydrogenCyanide();
            MustardGas();
            ZombieNeurotoxin();
            KnockoutGas();
            done = true;
        }
        public static void Main()
        {
            Armor();
            Gas();

            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                //ModAPI.Notify("Object is " + obj.ToString());
                GameObject gameobject = obj.Instance;
                PersonBehaviour person = gameobject.GetComponent<PersonBehaviour>();
                if (person)
                {
                    foreach (LimbBehaviour limb in person.Limbs)
                    {
                        if (limb.SpeciesIdentity != "Human")
                            break;
                        if (!limb.GetComponentInChildren<SymptomBehaviour>())
                        {
                            GameObject symptomObject = new GameObject();
                            symptomObject.transform.parent = limb.transform;
                            symptomObject.transform.localPosition = Vector3.zero;
                            symptomObject.AddComponent<Optout>();
                            SymptomBehaviour symptom = symptomObject.AddComponent<SymptomBehaviour>();
                            symptom.gasCapacity = 1f;
                            symptom.limb = limb;
                            symptom.person = person;
                        }
                        if (limb.RoughClassification == LimbBehaviour.BodyPart.Head && !limb.IsAndroid && !limb.GetComponentInChildren<BreatheBehaviour>())
                        {
                            GameObject breatheObject = new GameObject();
                            breatheObject.transform.parent = limb.transform;
                            breatheObject.transform.localPosition = Vector3.zero;
                            breatheObject.AddComponent<Optout>();
                            BreatheBehaviour breath = breatheObject.GetOrAddComponent<BreatheBehaviour>();
                            breath.gasCapacity = 6f;
                            breath.limb = limb;
                            breath.person = person;
                        }
                    }
                }
            };
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Small I-Beam"), //item to derive from
                    NameOverride = "Gas Canister - ChemW", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "A - ChemW",
                    DescriptionOverride = "Canister of human suffering.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Explosives"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/chlorineView.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/ChlorineCanister.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        CanisterBehaviour canister = Instance.GetOrAddComponent<CanisterBehaviour>();
                        canister.gasCapacity = 2800f;
                        canister.releaseAmount = 14f;
                        canister.releasePoint = new Vector3(0, .55f);
                        canister.releaseVelocity = new Vector3(0, .75f);
                        canister.FillGas("mustard gas");
                        AudioSource audio = Instance.AddComponent<AudioSource>();
                        audio.clip = gasSounds[1];
                        audio.enabled = false;
                        audio.loop = true;
                        audio.volume = 0.25f;
                        canister.audio = audio;

                        Instance.GetOrAddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprites/ChlorineCanister.png"),
                            ModAPI.LoadSprite("sprites/PlainCanister.png"),
                        };

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "Gas Grenade - ChemW", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "A1 - ChemW",
                    DescriptionOverride = "Spreads selected gas.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Explosives"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/grenadeView.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/GasGrenade.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        CanisterBehaviour canister = Instance.GetOrAddComponent<CanisterBehaviour>();
                        canister.gasCapacity = 350f;
                        canister.releaseAmount = 10f;
                        canister.releasePoint = new Vector3(0, ModAPI.PixelSize * 4);
                        canister.releaseVelocity = new Vector3(0, .25f);
                        canister.FillGas("mustard gas");
                        canister.fuse = 5;
                        AudioSource audio = Instance.AddComponent<AudioSource>();
                        audio.clip = gasSounds[1];
                        audio.enabled = false;
                        audio.loop = true;
                        audio.volume = 0.25f;
                        canister.audio = audio;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "Gas Mask - ChemW", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "A - ChemW",
                    DescriptionOverride = "Prevents breathing deadly gases. Doesn't protect the skin.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/gasmaskView.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetOrAddComponent<ArmorBehaviour>().propName = "gasmask";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "Hazmat Suit - ChemW", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "A1 - ChemW",
                    DescriptionOverride = "Prevents breathing and skin contact with deadly gases. Covers the entire body.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/hazmatView.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetOrAddComponent<ArmorBehaviour>().propName = "hazmat1";

                        if (!Instance.GetComponent<ArmorSetBehaviour>())
                        {
                            ArmorSetBehaviour set = Instance.AddComponent<ArmorSetBehaviour>();

                            string[] armorSet = new string[13];
                            armorSet[0] = "hazmat2";
                            armorSet[1] = "hazmat3";
                            armorSet[2] = "hazmat4";
                            armorSet[3] = "hazmat5";
                            armorSet[4] = "hazmat6";
                            armorSet[5] = "hazmat7";
                            armorSet[6] = "hazmat8";
                            armorSet[7] = "hazmat9";
                            armorSet[8] = "hazmat10";
                            armorSet[9] = "hazmat11";
                            armorSet[10] = "hazmat12";
                            armorSet[11] = "hazmat13";
                            armorSet[12] = "hazmat14";

                            set.set = armorSet;
                            set.SpawnArmor();
                        }
                    }
                }
            );
        }
    }
}